stages:
  - test

variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

default:
  image: python:3.11-slim
  cache:
    paths:
      - .cache/pip
      - .venv
    key: "${CI_COMMIT_REF_SLUG}"
  before_script:
    - export POETRY_HOME=poetry_home
    - python -m venv $POETRY_HOME
    - pip install poetry==1.6.1
    - export PATH="$POETRY_HOME/bin/:$PATH"
    - poetry config virtualenvs.in-project true
    - poetry install

Run_Tests:
  stage: test
  script:
    - poetry run coverage_report
  coverage: '/TOTAL.*\s+(\d+%)$/'

Run_Mypy:
  stage: test
  script:
    - poetry run mypy

Run_Flake8:
  stage: test
  script:
    - poetry run flake8 abstract_factory tests

Run_Pylint:
  stage: test
  script:
    - poetry run pylint abstract_factory tests

